using System;
using System.Data;
using System.Data.Common;
using System.Data.OleDb;

namespace ShopClassLibrary
{
	public enum ShopStatusEnum 
	{
		OK					=  1,
		NOT_OK				=  0,
		INVALID_LOGIN		= -1,
		INVALID_KEY			= -2,
		INVALID_CUSTOMER_ID	= -3,
		INVALID_PRODUCT_ID	= -4,
		INSUFICIENT_STOCK	= -5,
		ERROR				= -6
	}

	/// <summary>
	/// Summary description for Comum.
	/// </summary>
	internal class Comum
	{
		public const string CONN = @"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\MyDBs\Sales.mdb;User ID=;Password=;";

		public Comum()
		{
			//
			// TODO: Add constructor logic here
			//
		}

		static public ShopStatusEnum ValidateUser(string user, string pass)
		{
			ShopStatusEnum status = ShopStatusEnum.OK;
			OleDbCommand    cmd  = null;
			OleDbConnection conn = null;

			try
			{
				//
				// criar objecto de conexo  base de dados e abrir a conexo
				//
				conn = new OleDbConnection(CONN);
				conn.Open();

				//
				// criar comando SQL a executar
				//
				cmd = new OleDbCommand("Select * from Users Where User='" + user + "' and Pass='" + pass + "'", conn);

				//
				// executar o comando e obter um DataReader
				//
				OleDbDataReader dr = cmd.ExecuteReader();

				//
				// verificar se retornou dados 
				// ( necessrio manter a conexo aberta pois estamos a usar um DataReader)
				//
				if (dr.HasRows)
					status = ShopStatusEnum.OK;
				else
					status = ShopStatusEnum.INVALID_LOGIN;

				dr.Close();
			}

			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO na validao do 'User': " + ex);
				status = ShopStatusEnum.ERROR;
			}

			finally
			{
				//
				// fechar a conexo
				//
				if (conn.State == ConnectionState.Open)
					conn.Close();
			}

			return status;
		}

		static public DataSet GetByID(string table, string keyName, long key)
		{
			DataSet ds = null;
			OleDbConnection conn = null;

			try
			{				
				//
				// criar objecto DataSet
				//
				ds = new DataSet();

				//
				// criar objecto de conexo  base de dados e abrir a conexo
				//
				conn = new OleDbConnection(CONN);
				conn.Open();

				//
				// criar um Datadapter para executar o comando e devolver o dataset
				//
				string sSqlCmd = "Select * From "+ table + " Where "+ keyName + " = "+ key.ToString();
				OleDbDataAdapter oAdapter = new OleDbDataAdapter(sSqlCmd, conn);

				//
				// executar o comando e preencher um Dataset
				//
				oAdapter.Fill(ds, table);
			}

			catch(OleDbException ex)
			{
				//
				// tratar a excepo!!!!
				//
				System.Console.WriteLine("EXCEPO no mtodo 'GetByID': " + ex);
				ds = null;
			}

			finally
			{
				//
				// fechar a conexo
				//
				if (conn.State == ConnectionState.Open)
					conn.Close();
			}

			return ds;
		}
	}
}
